#/bin/bash
#example : 40~50 PC Setting
export LANG=C
SHELL_PATH=$(pwd -P)
workdir="/tmp/wdir"
PortNum=24242
find $workdir -mindepth 1 -maxdepth 1 -mmin +30 -type d -exec rm -rf {} \;
cand=$1
mode=$2
threads=$3
if [ "$mode" = "" ]; then
   mode="normal"
fi

if [ "$threads" = "" ]; then
   threads=4
fi

addOpt="tasks.polyselect.P=100000 tasks.polyselect.admin=1e2 tasks.polyselect.admax=48e3 tasks.polyselect.adrange=480 tasks.polyselect.degree=5 tasks.polyselect.incr=60 tasks.polyselect.nq=15625 tasks.polyselect.nrkeep=40 tasks.polyselect.ropteffort=7 tasks.polyselect.sopteffort=1"

if [ "$mode" = "poly" ]; then
   addOpt="tasks.sieve.run=false $addOpt"
   PortNum=$(($PortNum + 1))
fi
workdir="$workdir/$cand"
if [ "$mode" = "normal" ]; then
  if [ -d "$workdir" ]; then
      for polyfile in "$workdir"/*.poly; do
         if [ -f "$polyfile" ]; then
            addOpt="tasks.polyselect.import=$polyfile $addOpt tasks.polyselect.admin=0 tasks.polyselect.admax=0 tasks.polyselect.adrange=0"
            break
         fi
      done
  fi
fi


cd $SHELL_PATH
cd ../cado-nfs
kill $(lsof -t -i:$PortNum)
./cado-nfs.py --server $cand tasks.workdir=$workdir server.port=$PortNum server.ssl=no server.whitelist=0.0.0.0/0 $addOpt tasks.filter.required_excess=0.07 tasks.filter.target_density=120.0 tasks.filter.purge.keep=170 tasks.qmin=1250000 tasks.lim0=4000000 tasks.lim1=5500000 tasks.lpb0=27 tasks.lpb1=28 tasks.sieve.lambda0=1.85 tasks.sieve.lambda1=1.92 tasks.sieve.mfb0=54 tasks.sieve.mfb1=57 tasks.sieve.ncurves0=13 tasks.sieve.ncurves1=18 tasks.sieve.qrange=6000 tasks.sieve.rels_wanted=19200000 tasks.polyselect.threads=32 --client-threads 5 -t all --no-colors

